/*
	A basic extension of the java.applet.Applet class
 */
import java.io.Serializable;
import java.net.URL;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
 
class Muhabere implements MuhabereInterface,	Serializable  {
    MuhabereInterface myp=null;
    GameServerInterface server;
    GameBase base;
    int port=2002;
    
    Muhabere(GameBase _base)
    {
	base=_base;
    }
//     public MuhabereInterface es(String p) throws RemoteException {
	
// 	myp.print("to message "+p);
// 	//return server.es(p);
// 	return myp;
//     }
    public void print (String message)  throws RemoteException
    {
	System.out.println(message);
    }
    public void displayMessage(String message)  throws RemoteException
    {
	base.networkMessage(message);
    }

    public void updatePlayerList(Hashtable pl) throws RemoteException
    {
	base.refreshPlayers(pl);
    }

    public boolean askPartnership(String candidate,String old)
    {
	try 
	    {  myp=server.askPartnership(base.mystate.name,candidate,old); 
	       if (myp!=null) return true; 
	    }
	catch (Exception e)    
	    { 
	    }
	return false; 
    }
    public void movePartner(String obj,int x,int y,int z)
    {
	System.out.println("sending  to"+base.mystate.partner);
	try 
	    { if (myp != null) myp.adaptPartner(obj,x,y,z) ; 
	    }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.movePartner()");   e.printStackTrace();
	    }
    }

    public void adaptPartner(String obj,int x,int y,int z)
    {
	System.out.println("receiving from partner"+obj);
	try 
	    { base.moveTo(obj,x,y,z);
	    }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.receive()");   e.printStackTrace();
	    }
    }
//     public void movePartner(String partner,String obj,int x,int y,int z)
//     {
// 	System.out.println("sending  to"+base.mystate.partner);
// 	try 
// 	    { if (myp != null) server.send(partner,obj,x,y,z) ; 
// 	    }
// 	catch (Exception e)    
// 	    { System.out.println("Client error: Muharebe.giveToPartner()");   e.printStackTrace();
// 	    }
//     }

//     public void adaptPartner(String obj,int x,int y,int z)
//     {
// 	System.out.println("receiving from partner"+obj);
// 	try 
// 	    { base.moveTo(obj,x,y,z);
// 	    }
// 	catch (Exception e)    
// 	    { System.out.println("Client error: Muharebe.receive()");   e.printStackTrace();
// 	    }
//     }

    public boolean available(String requester,MuhabereInterface r) 
    {
	if (base.setPartner(requester)) 
	    {
		myp=r;
		return true;
	    }
	return false;
    }

    public void deselect(String requester) 
    {
	base.deselectPartner(requester);
    }
    public void update(playerstate pl)
    {
	try     
	    { server.update(pl.name,(Object)pl); }
	catch (Exception e)        
	    { System.out.println("Client error: Muharebe.update()");   e.printStackTrace();
	    }
    }

    public void login(playerstate pl){ 
	try     
	    { server.login(this,(Object)pl,pl.name); }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.login()"); e.printStackTrace();
	    }
    }

    public void logout(playerstate pl)
    { 
	try     
	    { server.logout(pl.name); }
	catch (Exception e)    
	    { System.out.println("Client error: Muharebe.logout()"); e.printStackTrace();
	    }
    }

    public void register() 
    {
	boolean registered=false;
        int tries=0;
	while(!registered && tries <10) 
	    try
	    {
		System.out.println("Registering to server");
		server.register(this);  
		registered=true;
		System.out.println("done");
	    }
	catch (Exception e)
	    {
		tries++;
		connect();		//e.printStackTrace();
		return;
	    }
    }
    
    public void connect()
    {   
	try
	    { UnicastRemoteObject.exportObject(this);
	    }
	catch (Exception e)
	    { System.out.println("Error exporting ");  e.printStackTrace();
	    }
	try
	    { server = (GameServerInterface) Naming.lookup("//carver.npac.syr.edu:2002/GameServer");
	    }
	catch (Exception e)
	    {
		System.out.println("Error while lookup : server may be down"); e.printStackTrace();
		startServer();
	    }
	 
    }

    public void   startServer()
    {
	//         String command = "/usr/npac/java/bin/java /npac/home/msen7/GameServer &";

	//         try{
	//           BufferedReader HTML = null;
	//           URL url = new URL("http",host,URLPort,command);
	//           url.openConnection().setUseCaches(false);
	//           HTML=new BufferedReader(new InputStreamReader(url.openStream()));
	//          }catch (MalformedURLException ev){
	//            System.out.println("URL error in (run) " + ev);
	//          }
	//          catch (IOException ev){
	//            System.out.println("IOException in (run)"+ev+" host "+host+" URLPort "+URLPort+" command "+command);
	//          }
	//          boolean flag=false;
    }
} //Muhabere

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
class  playerstate implements     Serializable
{
    public String  name;
    public String  partner=null;
    public boolean golee;
    public boolean active=false;
    public boolean catching=false;
    public boolean shooting=false;
  
    playerstate (String _name,boolean g)
    {
	name=_name;
	golee=g;
    }
}

public class GameBase extends Applet implements     Serializable
{

    //CONTROLS
    java.awt.Panel networkPanel = new java.awt.Panel();
    java.awt.List gList = new java.awt.List(30);
    java.awt.List pList = new java.awt.List(30);
    java.awt.Checkbox pRB = new java.awt.Checkbox();
    java.awt.CheckboxGroup Group1 = new java.awt.CheckboxGroup();
    java.awt.Label nameLabel = new java.awt.Label();
    java.awt.TextField loginTxtField = new java.awt.TextField();
    java.awt.Button loginButton = new java.awt.Button();
    java.awt.Button logoutButton = new java.awt.Button();
    java.awt.Checkbox gRB = new java.awt.Checkbox();
    java.awt.Label statusLabel = new java.awt.Label();
    java.awt.Button startButton = new java.awt.Button();
    java.awt.Button sendB = new java.awt.Button();
    java.awt.Button receiveB = new java.awt.Button();
    //
    Muhabere network=new Muhabere(this);
    playerstate mystate;    
    String login="";

    public void init()
    {
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.pink);
		setSize(450,300);
		networkPanel.setLayout(null);
		add(networkPanel);
		networkPanel.setBackground(new java.awt.Color(128,255,128));
		networkPanel.setBounds(200,0,250,270);
		gList.addItem("ertan");
		gList.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
		gList.setBackground(java.awt.Color.black);
		gList.setForeground(java.awt.Color.lightGray);
		gList.setFont(new Font("Dialog", Font.BOLD, 12));
		networkPanel.add(gList);
		gList.setBounds(5,75,120,190);
		pList.addItem("ahmet");
		pList.addItem("mehmet");
		pList.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
		pList.setBackground(new java.awt.Color(0,128,0));
		pList.setForeground(java.awt.Color.yellow);
		pList.setFont(new Font("Dialog", Font.BOLD, 12));
		networkPanel.add(pList);
		pList.setBounds(125,75,120,190);
		pRB.setCheckboxGroup(Group1);
		pRB.setLabel("Player");
		pRB.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
		networkPanel.add(pRB);
		pRB.setBackground(java.awt.Color.yellow);
		pRB.setForeground(new java.awt.Color(0,128,0));
		pRB.setFont(new Font("Dialog", Font.BOLD, 12));
		pRB.setBounds(125,55,120,20);
		nameLabel.setText(" Player Name");
		nameLabel.setAlignment(java.awt.Label.CENTER);
		nameLabel.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.E_RESIZE_CURSOR));
		networkPanel.add(nameLabel);
		nameLabel.setBackground(new java.awt.Color(0,128,128));
		nameLabel.setForeground(java.awt.Color.yellow);
		nameLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		nameLabel.setBounds(5,5,120,30);
		loginTxtField.setText("none");
		networkPanel.add(loginTxtField);
		loginTxtField.setBackground(new java.awt.Color(196,227,224));
		loginTxtField.setBounds(125,5,120,30);
		loginButton.setLabel("Login");
		loginButton.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
		networkPanel.add(loginButton);
		loginButton.setBackground(new java.awt.Color(0,64,128));
		loginButton.setForeground(java.awt.Color.yellow);
		loginButton.setFont(new Font("Dialog", Font.BOLD, 14));
		loginButton.setBounds(5,35,120,20);
		logoutButton.setLabel("Logout");
		logoutButton.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
		networkPanel.add(logoutButton);
		logoutButton.setBackground(java.awt.Color.red);
		logoutButton.setForeground(java.awt.Color.yellow);
		logoutButton.setFont(new Font("Dialog", Font.BOLD, 12));
		logoutButton.setBounds(125,35,120,20);
		gRB.setCheckboxGroup(Group1);
		gRB.setState(true);
		gRB.setLabel("Golee");
		gRB.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.HAND_CURSOR));
		networkPanel.add(gRB);
		gRB.setBackground(java.awt.Color.lightGray);
		gRB.setForeground(java.awt.Color.black);
		gRB.setFont(new Font("Dialog", Font.BOLD, 12));
		gRB.setBounds(5,55,120,20);
		
		statusLabel.setText("Please login first");
		statusLabel.setAlignment(java.awt.Label.CENTER);
		add(statusLabel);
		statusLabel.setBackground(java.awt.Color.orange);
		statusLabel.setBounds(0,270,449,30);
		startButton.setLabel("start game");
		add(startButton);
		startButton.setBackground(java.awt.Color.red);
		startButton.setForeground(java.awt.Color.white);
		startButton.setFont(new Font("Dialog", Font.BOLD, 16));
		startButton.setBounds(5,5,190,30);
		sendB.setLabel("send");
		add(sendB);
		sendB.setBackground(java.awt.Color.lightGray);
		sendB.setBounds(5,75,87,26);
		receiveB.setLabel("receive");
		add(receiveB);
		receiveB.setBackground(java.awt.Color.lightGray);
		receiveB.setBounds(105,75,90,34);
		//}}

		//{{REGISTER_LISTENERS
		SymItem lSymItem = new SymItem();
		gRB.addItemListener(lSymItem);
		pRB.addItemListener(lSymItem);
		pList.addItemListener(lSymItem);
		SymAction lSymAction = new SymAction();
		gList.addActionListener(lSymAction);
		gList.addItemListener(lSymItem);
		loginButton.addActionListener(lSymAction);
		SymText lSymText = new SymText();
		loginTxtField.addTextListener(lSymText);
		startButton.addActionListener(lSymAction);
		logoutButton.addActionListener(lSymAction);
		receiveB.addActionListener(lSymAction);
		//}}
		
		
    saha=getImage(getDocumentBase(), "kaleBig.gif")	;
    kale=getImage(getDocumentBase(), "kale.gif")	;
    top=getImage(getDocumentBase(), "top.gif")	;
    
    System.out.println("Looking network connections.");
    network.register();
    }

    private Image kale,saha,top,kaleci,kaleciL,kaleciR; //pre load image names
    public void paint (Graphics g)  
    { 
	g.drawImage(saha,250,0,this);
	g.drawImage(kale,-70,50,this);
	g.drawImage(top,75,100,this);
    }

    public void destroy()
    {
	  network.logout(mystate);
    }
    public void deactivate()
    {
	mystate.active=false;
	network.update(mystate);
    }

    public void networkMessage(String m) 
    {
	statusLabel.setText(m);
    }

    public void inAction() 
    {
	mystate.catching=true;
	mystate.shooting=true;
	network.update(mystate);
	statusLabel.setText("P E N A L T Y");
    }
    public void actionEnd() 
    {
	mystate.catching=false;
	mystate.shooting=false;
	network.update(mystate);
	statusLabel.setText("....");
    }

		  

    public void refreshPlayers(Hashtable pl) {
	System.out.println("refreshing");
	try 
	    {
		pList.removeAll();
		gList.removeAll();
		playerstate p;
		String u;
		int gI=0,pI=0;
		Enumeration e = pl.elements();
		while (e.hasMoreElements())
		    {
			p  = (playerstate) e.nextElement();
			u=p.name;
			if (p.partner!=null) 
			    u="~"+u;
			if (p.golee) {
			    if (p.active) {
				if (p.catching) 
				    u+= " @";
				else u+= " !";
			    }
			    gList.add(u);
			    if (mystate.partner!=null&&mystate.partner.equals(p.name)) 
				gList.select(gI);
			    gI++;
			} else {
			    if (p.active) {
				if (p.shooting)
				    u+= " *";
				else u+= " !";
			    }
			    pList.add(u);
			    if (mystate.partner!=null&&mystate.partner.equals(p.name)) 
				pList.select(pI);
			    pI++;
			}
		    }
	    }   
	catch (Exception e)
	    { System.out.println("Error while refreshing.");  e.printStackTrace();
	    }
    }

    public boolean setPartner(String p)
    {
	if (mystate.partner==null ) {
	    mystate.partner=p;
	    List l;
	    if (mystate.golee) 
		l=pList;
	    else l=gList;
	    for (int i=0; i<l.getItemCount() ;i++) 
		if (p.equals(l.getItem(i)))
		    l.select(i);
	    statusLabel.setText(p+ " invites you to play");
	    network.update(mystate);
	    return true;
	}
	else if (mystate.partner.equals(p) ) return true;
	else return false;
    }

    public void  deselectPartner(String p)
    {
	if (mystate.partner.equals(p)) {
	    mystate.partner=null;
	    List l;
	    if (mystate.golee) 
		l=pList;
	    else l=gList;
	    l.deselect(l.getSelectedIndex());
	    statusLabel.setText ( p + " says bye bye to you.");
	    network.update(mystate);
	}
    }
//     public void  giveToPartner(String otype,Object o)
//     {
// 	System.out.println("giveToPartner");
// 	if (mystate.partner !=null) {
// 	    network.giveToPartner(mystate.partner,otype,o );
// 	    System.out.println("giveToPartner OK");
// 	}	

//     }

//     public void  received(String otype,Object o)
//     {
// 	if (net !=null)
// 	      net.kale.setCopy(otype,o);
// 	// net.kale.setCopy((DrawCanvas)o);
	
//     }
//     public void  movePartner(String otype,int x,int y,int z)
//     {
// 	System.out.println("base moveto");
// 	if (mystate.partner !=null) {
// 	    network.movePartner(mystate.partner,otype,x,y,z);
// 	    System.out.println("base moveto OK");
// 	}	

//     }

    public void  moveTo(String otype,int x,int y,int z)
    {
	if (net !=null)
	      net.kale.moveTo(otype,x,y,z);
	// net.kale.setCopy((DrawCanvas)o);
	
    }

    // actions
	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == gRB)
				gRB_ItemStateChanged(event);
			else if (object == pRB)
				pRB_ItemStateChanged(event);
			else if (object == pList)
				pList_ItemStateChanged(event);
			else if (object == gList)
				gList_ItemStateChanged(event);
		}
	}

	void gRB_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.
			 
		gRB_ItemStateChanged_Interaction1(event);
			 
		gRB_ItemStateChanged_Interaction2(event);
	}

	void pRB_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.
			 
		pRB_ItemStateChanged_Interaction1(event);
			 
		pRB_ItemStateChanged_Interaction2(event);
	}

	void pList_ItemStateChanged(java.awt.event.ItemEvent event)
	{
	  list_ItemStateChanged(pList,pRB);
	  // to do: code goes here.
		
	  //		pList_ItemStateChanged_Interaction1(event);
	}

	void pList_ItemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		try {
			statusLabel.setText(pList.getSelectedItem());
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == gList)
				gList_ActionPerformed(event);
			else if (object == loginButton)
				loginButton_ActionPerformed(event);
			else if (object == startButton)
				startButton_ActionPerformed(event);
			else if (object == logoutButton)
				logoutButton_ActionPerformed(event);
			else if (object == receiveB)
				receiveB_ActionPerformed(event);
		}
	}

	void gList_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
	}

	void gList_ItemStateChanged(java.awt.event.ItemEvent event)
	{
	  list_ItemStateChanged(gList,gRB);
	}
  void list_ItemStateChanged(List lst,Checkbox rb) {

		// to do: code goes here.
	  String si=lst.getSelectedItem();
	  int  i=lst.getSelectedIndex();
	 
	  si=si.replace('~',' ').replace('@',' ').replace('*',' ').replace('!',' ').trim();
	  //System.out.println(si);
	  //for (int in=0;in <255;in++)  System.out.print((char)in+in);
	  if (mystate==null) {
	    statusLabel.setText("Login first");
	    lst.deselect(i); 
	  }
	  else if (  rb.getState()  || mystate.name.equals(si) ) {
	     lst.deselect(i); 
	     statusLabel.setText("Illegal selection");
	     return;
	  }  
	  else if (network.askPartnership(si, mystate.partner)) {
	    mystate.partner=si;
	    statusLabel.setText("Play with "+si);
	    network.update(mystate);
	    
	  } else { 
	    lst.deselect(i);   
	    statusLabel.setText("Leave partner");
	    mystate.partner=null;
	    network.update(mystate);
	  }
	  //  gList_ItemStateChanged_Interaction1(event);
	}

	void gList_ItemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		try {
			statusLabel.setText("Play with "+gList.getSelectedItem());
		} catch (Exception e) {
		}
	}

	void gRB_ItemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		try {
			pRB.setState(false);
		} catch (Exception e) {
		}
	}

	void pRB_ItemStateChanged_Interaction1(java.awt.event.ItemEvent event)
	{
		try {
			gRB.setState(false);
		} catch (Exception e) {
		}
	}

	void gRB_ItemStateChanged_Interaction2(java.awt.event.ItemEvent event)
	{
		try {
			statusLabel.setText("You are golee now");
		} catch (Exception e) {
		}
	}

	void pRB_ItemStateChanged_Interaction2(java.awt.event.ItemEvent event)
	{
		try {
			statusLabel.setText("You are player now");
		} catch (Exception e) {
		}
	}

	void loginButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  network.logout(mystate);
	  System.out.println("LOGIN: "+loginTxtField.getText()+" golee="+gRB.getState());
	  mystate= new playerstate(loginTxtField.getText() ,gRB.getState());
	  network.login(mystate);
	  loginButton_ActionPerformed_Interaction1(event);
	}

	void loginButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			statusLabel.setText("Login to the server");
		} catch (Exception e) {
		}
	}

	class SymText implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
			Object object = event.getSource();
			if (object == loginTxtField)
				loginTxtField_TextValueChanged(event);
		}
	}

	void loginTxtField_TextValueChanged(java.awt.event.TextEvent event)
	{
		// to do: code goes here.
	  //mystate.name=loginTxtField.getText();
	  loginTxtField_TextValueChanged_Interaction1(event);
	}

	void loginTxtField_TextValueChanged_Interaction1(java.awt.event.TextEvent event)
	{
		try {
			statusLabel.setText(loginTxtField.getText());
		} catch (Exception e) {
		}
	}

	  NetWindow net;
    void startButton_ActionPerformed(java.awt.event.ActionEvent event)
    {
		// to do: code goes here.
			 
	startButton_ActionPerformed_Interaction1(event);
	if (mystate.golee)
	    {
		net = new NetWindow("Penalty Shootings");  //open net window frame
		net.setParent(this);                        //send applet to the frame for image loading
		net.setSize(550,550);	
		mystate.active=true;
		network.update(mystate);
	    } 
	else 
	    {
		net = new NetWindow("Penalty Shootings");  //open net window frame
		net.setParent(this);                        //send applet to the frame for image loading
		net.setSize(550,550);	
		mystate.active=true;
		network.update(mystate);
	    }
	
    }

	void startButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			statusLabel.setText("Starting the game");
		} catch (Exception e) {
		}
	}

	void logoutButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			  network.logout(mystate); 
			  mystate=null;
		logoutButton_ActionPerformed_Interaction1(event);
	}

	void logoutButton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			statusLabel.setText("Leaving active play");
		} catch (Exception e) {
		}
	}

	void receiveB_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		receiveB_ActionPerformed_Interaction1(event);
			 
		receiveB_ActionPerformed_Interaction2(event);
	}

	void receiveB_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			gList.addItem("gelen");
			//Muhabere m=(Muhabere)
			//    network.es(mystate.partner);
			//network.print(" test test test test test test test");
		} catch (Exception e) {
		    e.printStackTrace();
		}
	}

	void receiveB_ActionPerformed_Interaction2(java.awt.event.ActionEvent event)
	{
		try {
			gList.remove("leaving");
		} catch (Exception e) {
		}
	}
}
//______________________________________________________________________
//______________________________________________________________________
//______________________________________________________________________
//______________________________________________________________________
//______________________________________________________________________

//show actual Net and penalty shootings

class NetWindow extends Frame implements ActionListener,     Serializable  { //, ItemListener,AdjustmentListener{
  private Button quit,shoot;       // action buttons to exit and penalty shootings
  private Scrollbar Hscrollbar;   // to adjust target point of the penalty
  private Scrollbar Vscrollbar;
  public  DrawCanvas kale;      // include penalty images
  private GameBase applet;         // parent of the frame, for image loading purposes 

  // get parent applet and send it to the child components, 
  // for necessary methods of applet.
  public void setParent(GameBase a ) {
    applet =a;
    kale.setApplet(applet);
    kale.start();
    kale.setBallX(Hscrollbar.getValue() );
    kale.setBallY(Vscrollbar.getValue() );
    //    applet.network.register(kale);
  }
  // constructor
   NetWindow(String title) {
    super(title);
    GridBagLayout gbl = new GridBagLayout(); //use GridBagLayout
    setLayout(gbl);

    int min = 0;    // minimum value of scrollbar
    int max = 100;  // maximum value of scrollbar
    int pos = 50;   // initial position of scrollbox
    int size = 5;   // relative size of the scrollbox
    Color lightBlue = new Color( 0xB0, 0xE0, 0xE6 );
         
    int orientation = Scrollbar.HORIZONTAL;
    Hscrollbar = new Scrollbar( orientation, pos, size, min, max );
    Hscrollbar.setBlockIncrement(10);
    Hscrollbar.setBackground( lightBlue );
    Hscrollbar.addAdjustmentListener( new ScrollbarHandlerX() );
 
    max = 95;  // maximum value of scrollbar
    orientation = Scrollbar.VERTICAL;
    Vscrollbar = new Scrollbar( orientation, pos, size, min, max );
    Vscrollbar.setBlockIncrement(10);
    Vscrollbar.setBackground( lightBlue );
    Vscrollbar.addAdjustmentListener( new ScrollbarHandlerY() );

    //scrollbars
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.weightx = 100;
    gbc.weighty = 0;
    add(Hscrollbar, gbl, gbc, 0, 10, 10, 1);
   
    gbc.fill = GridBagConstraints.VERTICAL;
    gbc.weightx = 0;
    gbc.weighty = 100;
    add(Vscrollbar, gbl, gbc, 10, 0, 1, 9);

    //canvas
    kale=new DrawCanvas();
    kale.setBackground(new Color(0,128,0));
    gbc.fill = GridBagConstraints.BOTH;
    gbc.weightx = 100;
    gbc.weighty = 100;
    add(kale, gbl, gbc, 0, 0, 10, 10);


    //buttons
    quit=new Button("X");
    quit.addActionListener(this);
    quit.setBackground( Color.red );
    quit.setForeground( Color.white ); 
    quit.setFont(new Font("SansSerif", Font.BOLD,12));

    shoot=new Button("!");
    shoot.addActionListener(this);
    shoot.setBackground( Color.blue );
    shoot.setForeground( Color.white ); 
    shoot.setFont(new Font("SansSerif", Font.BOLD,12));

    gbc.fill = GridBagConstraints.NONE;
    gbc.weightx = 0;
    gbc.weighty = 0;
    add(quit,gbl, gbc,10,10,1,1);
    add(shoot,gbl, gbc,10,9,1,1);
   
    setSize(550,550); 
    setVisible(true);
  }
  // carry GridBagLayout parameters 
  private void add(Component c, GridBagLayout gbl, GridBagConstraints gbc, 
                   int x, int y, int w, int h) {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbl.setConstraints(c, gbc);
    add(c);
  }
  ///EVENTS
  ///EVENTS
  ///EVENTS
  public void actionPerformed( ActionEvent e) {
      if (e.getSource()==quit) {
	  applet.deactivate();
	  dispose();
      }
    if (e.getSource()==shoot) {
	 kale.shoot();
	 System.out.println("shooting");
    }
  }
  
  //horizontal scrollbar listener
  class ScrollbarHandlerX implements AdjustmentListener {
    public void adjustmentValueChanged( AdjustmentEvent event ) {
      int v = event.getValue();
      kale.setBallX(v);
    }
  }
  //vertical listener
  class ScrollbarHandlerY implements AdjustmentListener {
    public void adjustmentValueChanged( AdjustmentEvent event ) {
      int v = event.getValue();
      kale.setBallY(v);
    }
  }
} //NetWindow

// show the net, ball images, provide animations for penalty kicks
class DrawCanvas extends Canvas // implements Serializable
{
    Graphics g;
    boolean noball=false;  //to keep the position of ball
    Graphics bufferg; //,appletG;
    GameBase applet;  //to be used for image loading
    Ball ball;       // controls ball animation
    Image kale,top,kaleci,vuran; // images, some for future extention
    Image buffer;   // used in double buffering 
    int topx,topy,w,h; // the target point of ball kick
    double rx,ry;     

    public DrawCanvas() 
    {
	setForeground(Color.red);
    }
    //to be used for image loading
    public void setApplet(GameBase a ) 
    {      
	applet =a;
    }
    //set the x dimension of the target
    public void setBallX( int x) 
    {      
	topx=(int)( x*rx)+25;
	repaint();
    }
    //set the y dimension of the target
    public void setBallY( int y) 
    {
	topy=(int)(y*ry)+25;  repaint();
    }
    public void ballgone( ) 
    {
	applet.actionEnd();
	noball=true;
    }
    //prepare penalty kick; images, etc.
    public void start( ) 
    {
	kale  = applet.getImage(applet.getDocumentBase(), "kaleBig.gif")	;
	//top  =  applet.getImage(applet.getDocumentBase(), "top.gif")	;
	w= getSize().width;
	h=getSize().height;
	rx=(double)(w-55)/95.0;
	ry=(double)(h-75)/90.0;
	buffer=createImage(getSize().width,getSize().height);
	bufferg=buffer.getGraphics();
	bufferg.drawImage(kale,0,0, applet);
	ball =new Ball(this, w/2 -50/2, h*10/12,100);//top.getWidth(applet));
	//ms=new MS();
	//    applet.giveToPartner("Ball",(Object)ball);
	//ball.parent=this;
    }
    public void shoot( ) 
    {
	if (noball) {
	    noball=false;
	    ball =new Ball(this, w/2 -50/2, h*10/12,100);//,top.getWidth(applet));
	    //ball.moveTo(w/2 -50/2, h*10/12,100);
	    // applet.giveToPartner("Ball",(Object)ball);
	    //ball.copy(applet.network.copy(ball,"ball",x,y));
	    repaint();
	    return;
	}
	applet.inAction();
	ball.setTarget(topx,topy);
	ball.start();
    }
    //perform penalty shoot
    public void update(Graphics g) 
    {
	paint(g);
    }
    public void paint(Graphics g) 
    {
	//    applet.network.tryi();
	//super.paint(g);
	g.drawImage(buffer, 0, 0, applet);
	g.fillOval(topx, topy, 11,11);
	//    mycopyMS.veli();
	ball.draw(g);
	//g.drawImage(top,(int)x,(int)y,(int)size,(int)size , parent.applet);
    }
    public void  moveTo(String o,int x,int y, int z)
    {
	//System.out.println("kale movinTo "+o+" "+x+y+z);
	if (o.equals("Ball")) ball.moveTo(x,y,z);
	else golee.moveTo(x,y,z);
    }
    //DrawCanvas mycopy;
    //MS mycopyMS;

    //MS ms;



//   public DrawCanvas  copy() {
//       return this;
//   }
//     public void setCopy( String otype, Object _obj) {
//       if (otype.equals("Ball"))
// 	  ball.setCopy(_obj);
// 	      //mycopy=_obj;
//   }
//   public void informBallGoing(int x,int y) {
//     if (mycopy!=null)
//       mycopy.updateBall(x,y);
//     System.out.println("mycopy.updateBall(x,y);"+x+y);
//   }
//   public void updateBall(int x,int y) {
//     if (ball!=null)
//       ball.moveto(x,y);
//     else ball =new Ball(this, x,y,top.getWidth(applet));
//     repaint();
//   }
//   public void setCopy(MS  _obj) {
//       //      mycopyMS=_obj;
//   }


} //draw canvas class ends 
// class MS implements Serializable {
//   DrawCanvas  parent;
//     MS(){}
//  public void    ali(){System.out.println("ali");}
//   public void   veli(){System.out.println("aliveli");}
// }



// keep track ball animation 
class MyObject implements Runnable {
    private Thread thread;        // a thread
    DrawCanvas  parent;
    Image pic;
    int tx,ty;
    double size;
    double x,y,z,dx=5;
    double  dv,ds,dy=5;
    double v=10;
    public MyObject(DrawCanvas p,int _x, int _y,int _z,String id, String picture) 
    { 
	parent=p;
	x=_x; y=_y; z=_z;
	pic  = parent.applet.getImage(parent.applet.getDocumentBase(), picture)	;
	size=pic.getWidth(parent.applet);
	//  size=_s;
	v=10;
	parent.applet.network.movePartner(id,(int)x,(int)y,(int) z);
    }
    public void draw(Graphics g)   //draw ball on the parent canvas class
    {
        g.drawImage(pic,(int)x,(int)y,(int)size,(int)size , parent.applet);
    }
    public void setTarget(int _x, int _y) 
    {
	tx=_x;
	ty=_y;
	dx=(double)(tx-x)/60.0;
	dy= (double)(y-ty)/60.0;
	ds=size/95.0;
	dv=15.0/100.0;
    }
    public void  moveTo(int _x,int _y, int _z)
    {
	x=_x;
	y=_y;
	z=_z;
	System.out.println("Ball moving To " +x+y+z);
	parent.repaint();
    }

  //start thread ; penalty shoot        
    public void start() 
    {
	if ( thread == null ) 
	    { 
		thread = new Thread( this );
		thread.start();
	    }
    }  
  // Override java.applet.Applet.stop:
  // stop thread; ball reached to the target
    public void stop() 
    {
	if ( thread != null ) 
	    { 
		thread.stop();
		thread = null;
	    }
    }
    // Implement java.lang.Runnable.run:
    // make moving ball animation
    public void run() 
    {
	while ( thread != null ) 
	    {
		move();
		try 
		    { Thread.sleep((int)v);
		    } 
		catch ( InterruptedException e ) 
		    {   
		    };    // Do nothing  
	    }
    }
    //Ball mycopy;
    // constructor
  //
//   public void init () 
//   {}
  // set the penalty target point of the ball
//   public void setCopy(Object o) {
//        System.out.println("mycopy is ready");
//       mycopy=(Ball)o;
//   }
} //ball class end 




// keep track ball animation 
class Ball extends MyObject  {
    private Thread thread;        // a thread
    DrawCanvas  parent;
    Image top;
    int tx,ty;
    double size;
    double x,y,z,dx=5;
    double  dv,ds,dy=5;
    double v=10;
    public Ball(DrawCanvas p,int _x, int _y,int _z) 
    { //,int _s
	parent=p;
	x=_x; y=_y; z=_z;
	top  = parent.applet.getImage(parent.applet.getDocumentBase(), "top.gif")	;
	size=top.getWidth(parent.applet);
	//  size=_s;
	v=10;
	parent.applet.network.movePartner("Ball",(int)x,(int)y,-3);
    }
    public void draw(Graphics g)   //draw ball on the parent canvas class
    {
        g.drawImage(top,(int)x,(int)y,(int)size,(int)size , parent.applet);
    }
    public void setTarget(int _x, int _y) 
    {
	tx=_x;
	ty=_y;
	dx=(double)(tx-x)/60.0;
	dy= (double)(y-ty)/60.0;
	ds=size/95.0;
	dv=15.0/100.0;
    }
    public void  moveTo(int _x,int _y, int _z)
    {
	x=_x;
	y=_y;
	z=_z;
	System.out.println("Ball moving To " +x+y+z);
	parent.repaint();
    }
    // move ball in a delta distance towards target point for animation 
    public void move() {
    x+=dx; y-=dy;
    // parent.informBallGoing((int)x,(int)y);
    //  mycopy.moveto((int)x,(int)y);
    size-=ds;
    v+=dv;
    System.out.println("move(x,y);"+x+y);
    parent.applet.network.movePartner("Ball",(int)x,(int)y,(int) z);
    parent.repaint();
    //if (y <ty  (x <tx+10 || x> tx-10)) thread.stop(); 
    if (y <ty  ){ parent.ballgone();    
   thread.stop(); }
  }
  //start thread ; penalty shoot        
    public void start() 
    {
	if ( thread == null ) 
	    { 
		thread = new Thread( this );
		thread.start();
	    }
    }  
  // Override java.applet.Applet.stop:
  // stop thread; ball reached to the target
    public void stop() 
    {
	if ( thread != null ) 
	    { 
		thread.stop();
		thread = null;
	    }
    }
    // Implement java.lang.Runnable.run:
    // make moving ball animation
    public void run() 
    {
	while ( thread != null ) 
	    {
		move();
		try 
		    { Thread.sleep((int)v);
		    } 
		catch ( InterruptedException e ) 
		    {   
		    };    // Do nothing  
	    }
    }
    //Ball mycopy;
    // constructor
  //
//   public void init () 
//   {}
  // set the penalty target point of the ball
//   public void setCopy(Object o) {
//        System.out.println("mycopy is ready");
//       mycopy=(Ball)o;
//   }
} //ball class end 




